#!/usr/bin/env python3
#Sequitur Decompression Program

#First need to recover lengths of S (main), A (subst) registers. Also, beginning of subst rule value list beginSubValue.
#Compressed file begins with these numbers, as ascii numbers, delineated with keys S, A and B
#Lengths are encoded as ascii, so the ascii values have to be read and then converted to ints for the program to use them
#Once these lengths are extracted, following are the datasets coresponding to the main S register, then the A register tupples.
#For S register, it's simply a list that long. For the subst rules A, they're tupples concatenated (all delineated with spaces)

#Once S and A registers have been recreated, then begin scanning using the last replacement rule from A and making the 1 to 2 substitutions in S
#When done, S will contain the original data

print('\n\n%\nSequitur DecodeProgram\nPlease type the name of the sequitur-compressed file')
compressedFile=input(':')
#outfilename=input('please enter the name you''d like for your output file')
outfilename='sequiturDecompressedFile'
ft=open(compressedFile,'rb')
at=ft.read()
ft.close()
St=at.decode("UTF-8")			#St contains ALL the compressed data including size information, original S, A tupples
#print('UTF-8 values\n')
#for i in range(len(St)):
#	print(ord(St[i]),end=" ")

#Recover length of S register
key='S'
Stlength=''
kk=0
while St[kk]!=key:
	#print(chr(t[kk]), end="")
	Stlength=Stlength+St[kk]	#length of S register represented as a string of ascii chars for conversion to type int
	kk=kk+1
print('\nNumber chars used to encode SLength int',kk)
SLint=int(Stlength)			#convert stringlength to int
print(SLint,"Length of encoded S segister")
kk=kk+1					#skip key, point to next length data digit
deltakk=kk				#record the change in kk, so later, number of digits used to encode lengths can be calculated

#Recover length of A register
key='A'
Atlength=''
#don't reset kk here; following info comes after Stlength harvested above in the same string of chars
while St[kk]!=key:
	#print(chr(t[kk]), end="")
	Atlength=Atlength+St[kk]	#length of S register represented as a string of ascii chars for conversion to type int
	kk=kk+1
print('\nNumber chars used to encode ALength int',kk-deltakk)
ALint=int(Atlength)			#convert stringlength to int
print(ALint,"Length of encoded A segister")
kk=kk+1
deltakk=kk				#record the change in kk, so later, number of digits used to encode lengths can be calculated

#Recover begin substitution value in A register
key='B'
Abegin=''
#don't reset kk here; this info comes after Stlength harvested above in the same string of chars
while St[kk]!=key:
	#print(chr(t[kk]), end="")
	Abegin=Abegin+St[kk]	#length of S register represented as a string of ascii chars for conversion to type int
	kk=kk+1
print('\nNumber chars used to encode Abegin int',kk-deltakk)
ABint=int(Abegin)			#convert stringlength to int
print(ABint,"Recovered begin value of subst keys")
kk=kk+1					#skip last key, point at first byte in S register

#now kk is the offset for where the data exists
#Recover S register data
Sascii=St[kk:SLint+kk]		#skip length info & keys, begin with this string of chars, original S data
print('S register: converting recovered ascii to their equivalent integer values')
S=[]
for i in range(len(Sascii)):
	S.append(ord(Sascii[i]))
	#print(S[i],end=" ")
#Recover A register data
Aascii=St[SLint+kk:]		#immediately after original S data, A register tupples begin and go all the way to the end of the file
print('A register: converting recovered ascii to their equivalent integer values')
A=[[],[]]			#reconstruct the subst rules register
for i in range(ALint):
	A[0].append([ord(Aascii[2*i]),ord(Aascii[2*i+1])])	#reconstruct subst tupples
	A[1].append(ABint)					#reconstruct subst keys
	ABint=ABint+1

#print('\nExtracted Data\n:\n')
#print('S\n',S)
#print('A\n',A)

#Do substitutions in A to recover original data. Start with last value in subst register keys and work to the first
dd=ALint-1			#use ALint-1 since last index value is one less than length
SscanEnd=len(S)
while dd>=0:
	ss=0
	#print(dd,' ',A[0][dd],A[1][dd])
	while ss<SscanEnd:			#compare it with each value in S register
		#print(ss,S[ss],end="     ")
		if A[1][dd] == S[ss]:
			print("Rule Subst",A[1][dd],flush="True")
			S.pop(ss)			#remove substitution key
			SscanEnd=SscanEnd+1		#as values are subst back into S, it grows, so scan range needs to be increased
			S.insert(ss,A[0][dd][1])	#replace subst value [1]
			S.insert(ss,A[0][dd][0])	#replace subst value [0]
		ss=ss+1
	dd=dd-1


fo=open(outfilename,'wb')
fo.write(bytes(S))
fo.close()
print('finished decompressing',len(S),'bytes\nwrote file: ',outfilename,'         from your input file: ',compressedFile)

#for i in range(0,SLint):
#	if t[i]>=128 and t[i]<=256:		#if you want to filter out certain data from encoded data
#		print(t[i],end=" ")

